package com.bjsxt.commons;

import java.sql.*;
import java.util.ResourceBundle;

public class JdbcUtils {
    private static String driver;
    private static String url;
    private static String username;
    private static String password;

    static {
        try {
        ResourceBundle bundle = ResourceBundle.getBundle("db");
        driver =bundle.getString("jdbc.driver");
        url = bundle.getString("jdbc.url");
        username = bundle.getString("jdbc.username");
        password = bundle.getString("jdbc.password");
            Class.forName(driver);
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
    }
    //获取连接的方法
    public static Connection getConnection(){
        Connection conn = null;
        try {
            conn = DriverManager.getConnection(url,username,password);
        } catch (Exception throwables) {
            throwables.printStackTrace();
        }
        return conn;
    }
    //关闭链接
    public static void closeConnection(Connection conn, Statement state, ResultSet rs){
        if (conn != null) {
            try {
                conn.close();
            } catch (Exception throwables) {
                throwables.printStackTrace();
            }
        }
        if (state != null) {
            try {
                state.close();
            } catch (Exception throwables) {
                throwables.printStackTrace();
            }
        }
        if (rs != null) {
            try {
                rs.close();
            } catch (Exception throwables) {
                throwables.printStackTrace();
            }
        }
    }
    //回滚
    public static void huigun(Connection conn){
        if (conn != null){
            try {
                conn.rollback();
            } catch (SQLException throwables) {
                throwables.printStackTrace();
            }
        }
    }
}
