package com.bjsxt.dao.impl;

import com.bjsxt.commons.JdbcUtils;
import com.bjsxt.dao.UserManagerDao;
import com.bjsxt.pojo.Users;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

/**
 * 用户管理持久层
 */
public class UserManagerDaoImpl implements UserManagerDao {
    /**
     * 添加用户
     * @param users
     */
    @Override
    public void inserUser(Users users) {
        Connection conn = null;
        PreparedStatement ps = null;
        try {
            conn = JdbcUtils.getConnection();
            conn.setAutoCommit(false);
            ps = conn.prepareStatement("insert into user values (default ,?,?,?,?,?)");
            ps.setString(1,users.getUsername());
            ps.setString(2,users.getUsersex());
            ps.setString(3,users.getPhonenumber());
            ps.setString(4,users.getQqnumber());
            ps.setString(5,users.getUserpwd());
            ps.execute();
            conn.commit();
        }catch (Exception e){
            e.printStackTrace();
            JdbcUtils.huigun(conn);
        }finally {
            JdbcUtils.closeConnection(conn,ps,null);
        }
    }

    /**
     * 查询用户的持久层
     * @param users
     * @return
     */
    @Override
    public List<Users> selectUserByProperty(Users users) {
        Connection conn = null;
        PreparedStatement ps = null;
        ResultSet rs = null;
        List<Users> list = new ArrayList<>();
        try {
            conn=JdbcUtils.getConnection();
            String sql = createSQL(users);
            ps=conn.prepareStatement(sql);
            rs=ps.executeQuery();
            while (rs.next()){
                Users user = new Users();
                user.setQqnumber(rs.getString("qqnumber"));
                user.setUsername(rs.getString("username"));
                user.setPhonenumber(rs.getString("phonenumber"));
                user.setUserpwd(rs.getString("userpwd"));
                user.setUsersex(rs.getString("usersex"));
                user.setUserid(rs.getInt("userid"));
                list.add(user);
            }
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            JdbcUtils.closeConnection(conn,ps,rs);
        }
        return list;
    }
    //实现查询的字符串拼接
    private String createSQL(Users users){
        StringBuffer sb = new StringBuffer("select * from user where 1=1 ");
        if (users.getUsersex() != null && users.getUsersex().length() > 0){
            sb.append(" and usersex="+users.getUsersex());
        }
        if (users.getUsername() != null && users.getUsername().length()>0){
            sb.append(" and username="+users.getUsername());
        }
        if (users.getPhonenumber() != null && users.getPhonenumber().length()>0){
            sb.append(" and phonenumber="+users.getPhonenumber());
        }
        if (users.getQqnumber() != null && users.getQqnumber().length()>0){
            sb.append(" and qqnumber="+users.getQqnumber());
        }
        return sb.toString();
    }
}
