package com.bjsxt.web.filter;

import com.bjsxt.commons.Constants;
import com.bjsxt.pojo.Users;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import java.io.IOException;

/**
 * 判断当前客户浏览器是否登录的Filter
 */
@WebFilter(urlPatterns = {"*.do","*.jsp"})
public class UserLoginFilter implements Filter {
    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        //强转HttpServletRequest
        HttpServletRequest req = (HttpServletRequest) servletRequest;
        //获取请求信息的URI
        String requestURI = req.getRequestURI();
       /* 判断当前请求的是否为 login.jsp 或者 login.do，
        如果请求的是用户登录的资源那么需要放行。*/
        if (requestURI.indexOf("login.do") != -1 || requestURI.indexOf("login.jsp") != -1 || requestURI.indexOf("validateCode.do") != -1){
            filterChain.doFilter(servletRequest, servletResponse);
        }else {
            HttpSession session = req.getSession();
            Users user = (Users) session.getAttribute(Constants.USER_SESSION_KEY);
            if (user != null){
                filterChain.doFilter(servletRequest, servletResponse);
            }else {
                req.setAttribute(Constants.REQUEST_MSG,"不登录不好使！");
                req.getRequestDispatcher("login.jsp").forward(servletRequest, servletResponse);
            }
        }
    }



    @Override
    public void destroy() {

    }
}
