package com.bjsxt.web.servlet;

import com.bjsxt.commons.Constants;
import com.bjsxt.pojo.Users;
import com.bjsxt.service.UserLoginService;
import com.bjsxt.service.impl.UserLoginServiceImpl;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;

/**
 * 处理用户登录请求
 */
@WebServlet("/login.do")
public class UserLoginServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        //得到请求信息
        String username = req.getParameter("username");
        String userpwd = req.getParameter("userpwd");
        //链接用户登录
        try {
            String code = req.getParameter("code");
            HttpSession session = req.getSession();
            String randStr = (String)session.getAttribute("randStr");
            if (code.equals(randStr)){
                UserLoginService userLoginService = new UserLoginServiceImpl();
                Users user = userLoginService.userlogin(username, userpwd);
                //建立服务端与客户端的会话状态
                session.setAttribute(Constants.USER_SESSION_KEY,user);
                //实现用户在一处登录，使用ServletContest
                ServletContext servletContext = this.getServletContext();
                HttpSession temp = (HttpSession) servletContext.getAttribute(user.getUserid()+"");
                if (temp != null){
                    servletContext.removeAttribute(user.getUserid()+"");
                    temp.invalidate();
                }
                servletContext.setAttribute(user.getUserid()+"",session);
                //用重定向方法实现页面的跳转
                resp.sendRedirect("main.jsp");
            }else {
                req.setAttribute("msg","验证码输入错误！");
                req.getRequestDispatcher("login.jsp").forward(req,resp);
            }

        }catch (RuntimeException e){
            //如果用户名找不到就报当下错误
            req.setAttribute("msg",e.getMessage());
            req.getRequestDispatcher("login.jsp").forward(req,resp);
        }catch (Exception e){
            //中间系统出问题就报当下错误
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }
    }
}
