package com.bjsxt.web.servlet;

import com.bjsxt.pojo.Users;
import com.bjsxt.service.UserManagerService;
import com.bjsxt.service.impl.UserManagerServiceImpl;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 处理用户管理请求
 */
@WebServlet("/usermanager.do")
public class UserManagerServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        doPost(req, resp);
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        String flag = req.getParameter("flag");
        if ("addUser".equals(flag)){
            this.addUser(req,resp);
        }else if ("findUser".equals(flag)){
            this.findUser(req,resp);
        }
    }
    //处理添加用户请求
    private void addUser(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException{
        Users adduser = this.createUsers(req);
        try {
            UserManagerService userManagerService = new UserManagerServiceImpl();
            userManagerService.addUser(adduser);
            resp.sendRedirect("ok.jsp");
        }catch (Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }
    }
    //获取用户提交数据
    private Users createUsers(HttpServletRequest req){
        String username = req.getParameter("username");
        String usersex = req.getParameter("usersex");
        String phonenumber = req.getParameter("phonenumber");
        String qqnumber = req.getParameter("qqnumber");
        String userpawd = req.getParameter("userpawd");
        Users user = new Users();
        user.setUsersex(usersex);
        user.setUserpwd(userpawd);
        user.setQqnumber(qqnumber);
        user.setPhonenumber(phonenumber);
        user.setUsername(username);
        return user;
    }

    //用户的查询
    private void findUser(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException{
        Users user = this.createUsers(req);
        try {
            UserManagerService userManagerService = new UserManagerServiceImpl();
            List<Users> user1 = userManagerService.findUser(user);
            req.setAttribute("list",user1);
            req.getRequestDispatcher("Usermanage/viewUser.jsp").forward(req,resp);
        }catch (Exception e){
            e.printStackTrace();
            resp.sendRedirect("error.jsp");
        }
    }
}
